//
//  TestBDRuleEngineForExpressionAssignment.m
//  TestBDRuleEngineForExpressionAssignment
//
//  Created by narita on 2015/03/17.
//  Copyright (c) 2015年 narita. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <XCTest/XCTest.h>
#import "BDExpressionAssignment.h"
#import "BDRuleModel.h"
#import "BDRule.h"


@interface TestBDRuleEngineForExpressionAssignment : XCTestCase

@end

@implementation TestBDRuleEngineForExpressionAssignment

- (void)setUp
{
    [super setUp];
}

- (void)tearDown
{
    [super tearDown];
}

// 右辺の演算(絶対値の計算)
- (void)testAbs
{
    BDRuleModel* theModel;
    BDRule*      theRule1;
    BDRule*      theRule2;
    
    theRule1 = [BDRule ruleWithLhs:[NSPredicate predicateWithFormat:@"x >= 0"]
                               rhs:[BDExpressionAssignment assignmentWithKeyPath:@"y"
                                                                           value:@"x"]
                          priority:0];
    
    theRule2 = [BDRule ruleWithLhs:[NSPredicate predicateWithFormat:@"x < 0"]
                               rhs:[BDExpressionAssignment assignmentWithKeyPath:@"y"
                                                                           value:@"-x"]
                          priority:0];

    theModel = [[BDRuleModel alloc] initWithRules:@[theRule1, theRule2]];
    
    BDRuleContext* theContext;
    id theResult;
    
    theContext = [[BDRuleContext alloc] initWithModel:theModel];
    
    [theContext setValue:@0 forKey:@"x"];
    theResult = [theContext valueForKey:@"y"];
    XCTAssertEqualObjects(theResult, @0, @"");
    
    [theContext setValue:@1 forKey:@"x"];
    theResult = [theContext valueForKey:@"y"];
    XCTAssertEqualObjects(theResult, @1, @"");

    [theContext setValue:@-1 forKey:@"x"];
    theResult = [theContext valueForKey:@"y"];
    XCTAssertEqualObjects(theResult, @1, @"");
}

//複数のAssignmentを内包したassigmentクラスが必要か？
// f(x)
//       1                   if x = 1
//       x * f(x-1)          otherwise

// 再帰で0になる
- (void) testZero
{
    BDRuleModel* theModel;
    BDRule*      theRule1;
    BDRule*      theRule2;
    
    theRule1 = [BDRule ruleWithLhs:[NSPredicate predicateWithFormat:@"x > 0"]
                               rhs:[BDExpressionAssignment assignmentWithKeyPath:@"x"
                                                                           value:@"x - 1"]
                          priority:0];
    
    theRule2 = [BDRule ruleWithLhs:[NSPredicate predicateWithFormat:@"x = 0"]
                               rhs:[BDExpressionAssignment assignmentWithKeyPath:@"x"
                                                                           value:@"0"]
                          priority:0];
    
    theModel = [[BDRuleModel alloc] initWithRules:@[theRule1, theRule2]];
    
    BDRuleContext* theContext;
    id theResult;
    
    theContext = [[BDRuleContext alloc] initWithModel:theModel];
    
    [theContext setValue:@0 forKey:@"x"];
    theResult = [theContext valueForKey:@"x"];
    XCTAssertEqualObjects(theResult, @0, @"");
    
    [theContext setValue:@5 forKey:@"x"];
    theResult = [theContext valueForKey:@"x"];
    XCTAssertEqualObjects(theResult, @0, @"");
    
    [theContext setValue:@-1 forKey:@"x"];
    theResult = [theContext valueForKey:@"x"];
    XCTAssertEqualObjects(theResult, @-1, @"");
    
}

@end
